include "Zeropage.inc"
include "Vram.inc"
include "VVram.inc"
include "Chars.inc"

ext VVram_
ext CharPattern

pDestination equ ZW0
pSource equ ZW1
pColorMap equ ZW2
yCount equ ZB0
sourceOffset equ ZB1
destinationOffset equ ZB2

dseg
CharColors: public CharColors
    defs Char_End


cseg
ColorSource:
    defb 64,113 ; Ascii
    defb 17,89 ; Logo
    defb 1,97 ; Needle
    defb 16,101 ; Goal
    defb 44,113 ; Man
    defb 16,84 ; Monster
    defb 16,99 ; Lift
    defb 4,110 ; Item
    defb 0
InitVram: public InitVram
    lda #low CharPattern | sta <pSource
    lda #high CharPattern | sta <pSource+1

    lda #low PatternRam | sta <pDestination
    lda #high PatternRam | sta <pDestination+1

    ldx #0 | stx <sourceOffset | sty <destinationOffset
    do
        ldx <sourceOffset
        lda ColorSource,x
                                                            _deb: public _deb
    while ne
        inx
        sta <yCount
        lda ColorSource,x | inx
        stx <sourceOffset

        do
            ldy <destinationOffset
            sta CharColors,y | iny
            sty <destinationOffset

            pha
                ldy #0
                do
                    lda (<pSource),y | sta (<pDestination),y
                    iny
                    cpy #CharHeight
                while ne | wend
                lda <pSource | clc|adc #low CharHeight | sta <pSource
                lda <pSource+1 | adc #high CharHeight | sta <pSource+1

                lda <pDestination | clc|adc #low CharHeight | sta <pDestination
                lda <pDestination+1 | adc #high CharHeight | sta <pDestination+1
            pla
            dec <yCount
        while ne | wend
    wend
rts


; void ClearScreen();
cseg
ClearScreen_: public ClearScreen_
    pha
        lda #low Vram | sta <pDestination
        lda #high Vram | sta <pDestination+1
        lda #0
        ldx #4
        do
            ldy #0
            do
                sta (<pDestination),y | iny
            while ne | wend
            inc <pDestination+1
            dex
        while ne | wend
    pla
rts


; void Put(ptr<byte>, byte c);
dseg
Put_@Param0: public Put_@Param0
Put_pVram:
    defw 0
Put_@Param1: public Put_@Param1
Put_c:
    defb 0
cseg
Put_: public Put_
    pha
        lda Put_pVram | sta <pDestination
        lda Put_pVram+1 | sta <pDestination+1
        lda Put_c
        ldy #0
        sta (<pDestination),y
        tax
        lda <pDestination+1
        clc|adc #high(ColorMap-Vram)
        sta <pDestination+1
        lda CharColors,x
        sta (<pDestination),y

        lda Put_pVram | clc|adc #1 | tay
        lda Put_pVram+1 | adc #0 | tax
    pla
rts


; void VVramToVram();
cseg
VVramToVram_: public VVramToVram_
    pha
        lda #low VVram_ | sta <pSource
        lda #high VVram_ | sta <pSource+1
        lda #low Vram | sta <pDestination
        lda #high Vram | sta <pDestination+1
        lda #low ColorMap | sta <pColorMap
        lda #high ColorMap | sta <pColorMap+1
        lda #VVramHeight | sta <yCount
        do
            ldy #0
            do
                lda (<pSource),y
                sta (<pDestination),y
                tax
                lda CharColors,x
                sta (<pColorMap),y
                iny
                cpy #VVramWidth
            while ne | wend
            lda <pSource | clc | adc #low VVramWidth | sta <pSource
            lda <pSource+1 | adc #high VVramWidth | sta <pSource+1
            lda <pDestination | clc | adc #low VramWidth | sta <pDestination
            lda <pDestination+1 | adc #high VramWidth | sta <pDestination+1
            lda <pColorMap | clc | adc #low VramWidth | sta <pColorMap
            lda <pColorMap+1 | adc #high VramWidth | sta <pColorMap+1

            dec <yCount
        while ne | wend
    pla
rts
